# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with javadoc
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/hornetq/messaging/%{namedversion}-brew
%define maven2brewrepodir %{_javadir}/repository.jboss.com/maven2-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src
# Include '.' in reltag
%define reltag .GA
%define namedversion %{version}%{reltag}

Name:           hornetq
Version:        2.2.10
Release:        1%{reltag}.2%{?dist}
Epoch:          0
Summary:        Open source project to build a multi-protocol, embeddable, very high performance, clustered, asynchronous messaging system
License:        ASL 2.0
Group:          Development/Java
URL:            http://jboss.org/hornetq/
# svn export https://svn.jboss.org/repos/hornetq/tags/HornetQ_2_2_10_EAP_BUILD2/ hornetq-2.2.10
# Exported revision 11991.
# tar czf hornetq-2.2.10.GA-src.tar.gz hornetq-2.2.10
Source0:        hornetq-%{namedversion}-src.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-component-info.xml
# https://repository.jboss.org/nexus/service/local/artifact/maven/redirect?r=central&g=org.twitter4j&a=twitter4j&v=2.1.8&e=pom
Source3:        twitter4j-core.tgz
Patch0:         %{name}-no-resteasy.patch
Patch1:         %{name}-maven-offline.patch
BuildRequires:  java-devel
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-nodeps >= 0:1.7.1
BuildRequires:  ant-contrib >= 0:1.0-0.b3
BuildRequires:  aopalliance
BuildRequires:  classworlds >= 0:1.1
BuildRequires:  ivy
BuildRequires:  javacc >= 0:4.0
BuildRequires:  jakarta-commons-logging >= 0:1.1.0.jboss
BuildRequires:  jakarta-commons-pool
BuildRequires:  jboss-jms-1.1-api
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:  jboss-ejb3-build >= 0:1.0.0
BuildRequires:  jboss-transaction-1.0.1-api
BuildRequires:  jboss-jaspi-1.0-api
BuildRequires:  jboss-parent
BuildRequires:  jbossts >= 0:4.6.1
BuildRequires:  jboss-security-spi >= 0:2.0.3
BuildRequires:  jbosssx2 >= 0:2.0.3
BuildRequires:  jboss-microcontainer2 >= 0:2.0.6
BuildRequires:  jboss-common-core >= 0:2.2.14
BuildRequires:  jboss-integration >= 0:5.1.0
BuildRequires:  jbossws
BuildRequires:  netty >= 0:3.2.0
%if %with javadoc
BuildRequires:  apiviz >= 0:2.3.0
%endif
BuildRequires:  jboss-common-logging-spi >= 0:2.1.0
BuildRequires:  jboss-ejb3-ext-api >= 0:1.0.0
BuildRequires:  jboss-naming >= 0:5.0.3
BuildRequires:  junit >= 0:3.8.2
BuildRequires:  log4j >= 0:1.2.14
BuildRequires:  spring2-beans
BuildRequires:  spring2-context
BuildRequires:  spring2-core
BuildRequires:  spring2-jms
BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3.04
BuildRequires:  xml-commons-resolver12 >= 0:1.3.04
BuildRequires:  xerces-j2 >= 0:2.9.1

BuildRequires:  maven2 >= 0:2.0.7-8
BuildRequires:  maven-buildmagic-thirdparty-plugin
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source

Requires:       jakarta-commons-logging >= 0:1.1.0.jboss
Requires:       jboss-common-core >= 0:2.2.14
Requires:       jboss-common-logging-spi >= 0:2.1.0
Requires:       jboss-ejb-3.0-api
Requires:       jboss-ejb3-ext-api >= 0:1.0.0
Requires:       jboss-jaspi-1.0-api
Requires:       jboss-jms-1.1-api
Requires:       jboss-microcontainer2 >= 0:2.0.6
Requires:       jboss-naming >= 0:5.0.3
Requires:       jboss-security-spi >= 0:2.0.3
Requires:       jboss-transaction-1.0.1-api
Requires:       jbosssx2 >= 0:2.0.3
Requires:       jbossts >= 0:4.6.1
Requires:       jpackage-utils
Requires:       log4j >= 0:1.2.14
Requires:       netty >= 0:3.2.0

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root


%description
HornetQ is an open source project to build a multi-protocol, embeddable, very
high performance, clustered, asynchronous messaging system. HornetQ is the 
new ultra high performance enterprise grade messaging system from JBoss, 
sets a record breaking score in the SPECjms2007 industry standard benchmark 
for JMS messaging system performance.

%if %with javadoc
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package examples
Summary:        Examples for %{name}
Group:          Development/Documentation

%description examples
%{summary}.

%prep
%setup -q
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1

%{_bindir}/find -type f -name "*jar" | %{_bindir}/xargs -t %{__rm}
#for i in `%{_bindir}/find . -name pom.xml`; do sed -i -e "s:<version>2.2.0.CR1</version>:<version>2.2.1.GA</version>:" $i; done

%build
export LANG=en_US.UTF-8
export JAVA_HOME=/usr/lib/jvm/java
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
export MAVEN_REPO_BREW=$(pwd)/maven2-brew
mkdir -p $MAVEN_REPO_LOCAL

# XXX: (dwalluck): this is part of maven-offline.patch
%{__perl} -pi -e 's|\@MAVEN_SETTINGS\@|'${M2SETTINGS}'|;' \
              -e 's|\@MAVEN_REPO_LOCAL\@|'${MAVEN_REPO_LOCAL}'|;' \
              -e 's|\@JPP_DEPMAP_FILE\@|%{SOURCE1}|;' \
              -e 's|\@MAVEN_REPO_BREW\@|'${MAVEN_REPO_BREW}'|;' \
    build-maven.xml build-thirdparty.xml  

# Add any artifacts we cannot download to local repository
pushd $MAVEN_REPO_LOCAL
# We need a package for twitter4j-core
tar xzf %{SOURCE3}
popd

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        buildmagic-thirdparty:build-thirdparty

# XXX: (dwalluck): This works around maven-buildmagic-thirdparty-plugin issue on maven 2.0.8
[ -d thirdparty ] || mv target thirdparty

find thirdparty -name jaxb-api.jar

%{ant} -Dhornetq.run_script=true -Dnodownload=true

%if %with javadoc
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc
%endif

%install
%{__rm} -rf %{buildroot}

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp licenses/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/

# jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
for i in hornetq-bootstrap-sources hornetq-bootstrap \
   hornetq-core-sources hornetq-core \
   hornetq-jboss-as-integration-sources \
   hornetq-jboss-as-integration \
   hornetq-jms-sources hornetq-jms \
   hornetq-logging-sources hornetq-logging \
   hornetq-ra-sources hornetq-ra \
   hornetq-resources-sources hornetq-resources \
   jboss-mc jnp-client
do
install -p -m 644 build/jars/$i.jar \
     $RPM_BUILD_ROOT%{_javadir}/%{name}/$i-%{namedversion}.jar
done
# Install JDK5 compatible client jars
install -p -m 644 build/jars/hornetq-core-client-java5-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/hornetq-core-client-sources.jar
install -p -m 644 build/jars/hornetq-core-client-java5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/hornetq-core-client.jar
install -p -m 644 build/jars/hornetq-jms-client-java5-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/hornetq-jms-client-sources.jar
install -p -m 644 build/jars/hornetq-jms-client-java5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/hornetq-jms-client.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{namedversion}*; do ln -s ${jar} ${jar/-%{namedversion}/}; done)

#rar
CURDIR="`pwd`"
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/hornetq-ra.rar
pushd $RPM_BUILD_ROOT%{_javadir}/%{name}/hornetq-ra.rar
jar xf $CURDIR/build/jars/hornetq-ra.rar 
for i in hornetq-ra hornetq-core-client hornetq-jms
do
ln -sf %{_javadir}/%{name}/$i.jar .
done
popd

#sar
install -p -m 644 build/jars/*.sar \
     $RPM_BUILD_ROOT%{_javadir}/%{name}/

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.hornetq messaging %{namedversion} JPP %{name}

# eap example zip
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -p -m 644 build/jars/hornetq-eap-examples.zip $RPM_BUILD_ROOT%{_datadir}/%{name}/hornetq-eap-examples.zip

# javadoc
%if %with javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
%endif

# repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{namedversion}-brew`
sed -i "s/@VERSION@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 $RPM_BUILD_ROOT%{_datadir}/%{name}/hornetq-eap-examples.zip $RPM_BUILD_ROOT%{repodirlib}/
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
cp -p build/jars/* $RPM_BUILD_ROOT%{repodirlib}

# Install JDK5 compatible client jars
(cd $RPM_BUILD_ROOT/%{repodirlib}; rm hornetq-core-client.jar hornetq-core-client-sources.jar hornetq-jms-client.jar hornetq-jms-client-sources.jar; for jar in *-java5*; do mv ${jar} ${jar/-java5/}; done)

(cd $RPM_BUILD_ROOT/%{repodir}; %{_bindir}/mvn-jpp org.jboss.maven.plugins:maven-buildmagic-thirdparty-plugin:maven-deploy -Durl=file://%{buildroot}%{maven2brewrepodir} -DgroupId=org.hornetq -Dversion=%{namedversion}; cd -)
for i in hornetq-bootstrap \
   hornetq-core-client \
   hornetq-core \
   hornetq-jboss-as-integration \
   hornetq-jms \
   hornetq-jms-client \
   hornetq-logging \
   hornetq-ra \
   hornetq-resources \
   hornetq-service \
   jboss-mc \
   jnp-client; do
    cp -p %{buildroot}%{maven2brewrepodir}/org/hornetq/${i}/%{namedversion}/${i}-%{namedversion}.pom $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-${i}.pom
    %add_to_maven_depmap org.hornetq ${i} %{namedversion} JPP/%{name} ${i}
done
%if %without repolib
%{__rm} -r %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
rm -Rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%dir %{_javadir}/%{name}
%{_javadir}*/%{name}/*ar
%{_datadir}/maven2/poms/JPP*%{name}*.pom
%{_mavendepmapfragdir}/%{name}

%if %with javadoc
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%files examples
%defattr(0644,root,root,0755)
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/hornetq-eap-examples.zip

%changelog
* Fri Jan 6 2012 Dustin Kut Moy Cheung <dcheung@redhat.com> - 0:2.2.10-1.GA.2
- Upgrade to 2.2.10-build2.GA

* Thu Dec 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.10-1.GA.1
- Upgrade to 2.2.10.GA

* Fri Dec 9 2011 Danesh Mondegarian <dmondega@redhat.com> 0:2.2.8-3.GA.4
- Update sources for CR2
- Update hornetq-maven-offline.patch for new source

* Wed Nov 23 2011 Martha Benitez <mbenitez@redhat.com> 0:2.2.8-3.GA.3
- Update sources for CR1

* Thu Nov 10 2011 Danesh Mondegarian <dcheung@redhat.com> 0:2.2.8-3.GA.2
- Update sources

* Thu Nov 03 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2.8-3.GA.1
- 2.2.8.GA

* Wed Nov 02 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2.8-2.CR2.2
- Test build from the branch
- Package examples.zip into the examples subpackage

* Mon Oct 03 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.8-2.CR2.1
- Upgrade to 2.2.8.CR2

* Wed Aug 24 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.8-1
- Upgrade to 2.2.8.CR1

* Wed Jun 22 2011 Fernando Nasser <fnasser@redhat.com> 0:2.2.5-1
- Upgrade to 2.2.5.GA

- Upgrade to 2.2.4.GA

* Tue May 17 2011 Fernando Nasser <fnasser@redhat.com> 0:2.2.4-1
- Upgrade to 2.2.4.GA

* Thu Apr 28 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.3-2
- Remove R: javacc

* Wed Apr 27 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.3-1
- Upgrade to 2.2.3.EAP.GA

* Tue Apr 05 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.2-2.2
- Fix dist in Release

* Tue Apr 05 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.2-2.1
- Install JDK5 compatible client jars in repolib

* Tue Mar 29 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2.2-2
- Re-export

* Mon Mar 28 2011 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1
- Upgrade to 2.2.2.GA

* Tue Mar 15 2011 Martha Benitez <mbenitez@redhat.com> 0:2.2.1-1.GA.2
- Rebuild

* Tue Mar 15 2011 Martha Benitez <mbenitez@redhat.com> 0:2.2.1-1.GA.1
- 2.2.1.GA

* Tue Mar 08 2011 Fernando Nasser <fnasser@redhat.com> - 0:2.2.0-2.GA.2
- Rebuild for RHEL-6

* Wed Feb 23 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-2.GA.1
- Fix version

* Wed Feb 23 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2-2.GA.0
- Rebuild

* Wed Feb 23 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2-1.GA.0
- Upgrade to 2.2.GA
- Update patch0
- Package hornetq-eap-examples.zip

* Thu Feb 03 2011 Martha Benitez <mbenitez@redhat.com> 0:2.2.0-0.1.CR1.3
- Install JDK5 compatible client jars

* Tue Feb 01 2011 David Walluck <dwalluck@redhat.com> 0:2.2.0-0.1.CR1.2
- add patch to keep maven from going online for jar-rest
- install poms even if not generating repolib
- add workaround for thirdparty build on maven 2.0.8
- update jpp-depmap.xml to allow building on JPackage 6
- BuildRequires: jboss-ejb3-build >= 0:1.0.0
- Requires: jpackage-utils
- remove build root before install
- set LANG in case of unmappable characters

* Tue Feb 01 2011 Fernando nasser <fnasser@redhat.com> - 0:2.2.0-0.1.CR1.1
- Upgrade to 2.2.0.CR1

* Fri Jan 14 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-1.0
- Upgrade to 2.2.0
- Comment Patch0, remove-twitter.patch
- Add patch to remove resteasy, apiviz
- Bundle twitter4j-core
- Add BR aopalliance, jakarta-commons-pool, spring-core, spring-beans, spring-context, spring-jms

* Wed Aug 18 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.2-1.Final.0
- Upgrade to 2.1.2.Final

* Wed Jun 16 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.1-1.Final.0
- Upgrade to 2.1.1.Final

* Mon Jun 14 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.0-2.Final.4
- add poms to main package

* Fri Jun 11 2010 David Walluck <dwalluck@redhat.com> 0:2.1.0-2.Final.3
- install poms to system as well
- fix component-info.xml in repolib

* Fri Jun 11 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.0-2.Final.2
- Fix repolib

* Fri Jun 11 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.0-2.Final.1
- Call buildmagic plugin during the build

* Fri Jun 04 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.0-2.Final
- Build from 2.1.0.Final tag

* Mon May 31 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.0-1.CR1
- Build from 2.1.0.CR1 tag

* Wed May 12 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.0-1.1.CR3
- Make it a noarch build

* Tue Apr 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.0-1.CR3
- First release
